---
title: XMLHttpRequest.responseXML
slug: Web/API/XMLHttpRequest/responseXML
tags:
  - AJAX
  - API
  - Fetching XML
  - Loading XML
  - Property
  - Read-only
  - Reading XML
  - Reference
  - Transfer
  - XML
  - XMLHttpRequest
  - download
  - responseXML
  - upload
---
<div>{{APIRef('XMLHttpRequest')}}</div>

<p>The <strong><code>XMLHttpRequest.responseXML</code></strong> read-only property returns a {{domxref("Document")}} containing the HTML or XML retrieved by the request; or <code>null</code> if the request was unsuccessful, has not yet been sent, or if the data can't be parsed as XML or HTML.</p>

<div class="note">
<p><strong>Note:</strong> The name <code>responseXML</code> is an artifact of this property's history; it works for both HTML and XML.</p>
</div>

<p>Usually, the response is parsed as "<code>text/xml</code>". If the {{domxref("XMLHttpRequest.responseType", "responseType")}} is set to "<code>document</code>" and the request was made asynchronously, instead the response is parsed as "<code>text/html</code>". <code>responseXML</code> is <code>null</code> for any other types of data, as well as for <a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/Data_URIs"><code>data:</code> URLs</a>.</p>

<p>If the server doesn't specify the {{HTTPHeader("Content-Type")}} as "<code>text/xml</code>" or "<code>application/xml</code>", you can use {{domxref("XMLHttpRequest.overrideMimeType()")}} to parse it as XML anyway.</p>

<p>This property isn't available to workers.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>data</var> = <var>XMLHttpRequest</var>.responseXML;
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("Document")}} from parsing the XML or HTML received using {{domxref("XMLHttpRequest")}}, or <code>null</code> if no data was received or if the data is not XML/HTML.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>InvalidStateError</code></dt>
 <dd>The {{domxref("XMLHttpRequest.responseType", "responseType")}} isn't either "<code>document</code>" or an empty string.</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">var xhr = new XMLHttpRequest;
xhr.open('GET', '/server');

// If specified, responseType must be empty string or "document"
xhr.responseType = 'document';

// Force the response to be parsed as XML
xhr.overrideMimeType('text/xml');

xhr.onload = function () {
  if (xhr.readyState === xhr.DONE &amp;&amp; xhr.status === 200) {
    console.log(xhr.response, xhr.responseXML);
  }
};

xhr.send();</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('XMLHttpRequest', '#the-responsexml-attribute', 'responseXML')}}</td>
   <td>{{Spec2('XMLHttpRequest')}}</td>
   <td>WHATWG living standard</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XMLHttpRequest.responseXML")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("XMLHttpRequest")}}</li>
 <li>{{domxref("XMLHttpRequest.response")}}</li>
 <li>{{domxref("XMLHttpRequest.responseType")}}</li>
 <li><a href="/en-US/docs/Web/Guide/Parsing_and_serializing_XML">Parsing and serializing XML</a></li>
 <li>Parsing XML into a DOM tree: {{domxref("DOMParser")}}</li>
 <li>Serializing a DOM tree into XML: {{domxref("XMLSerializer")}} (specifically, the {{domxref("XMLSerializer.serializeToString", "serializeToString()")}} method)</li>
</ul>
